------------------------------------------------------------
-- Defaults.lua
--
-- Abin
-- 2010/10/30
------------------------------------------------------------

local module = CompactRaid:GetModule("CornerIndicators")
if not module then return end

module.defaultsDB = {}

module.DEFAULT_SPELLS = {
	PRIEST = {
		139,--"֏",
		17,--"g:",
		33076,--"K϶\",
		21562,--"g:g",
		6346,--"oֽ֑Y",
	},
	DRUID = {
		774,--"شg",
		8936,--"K",
		33763,--"֮",
		48438,--"ҰȬK",
		29166,--"",
		1126,--"Ұӡӛ",
	},
	SHAMAN = {
		974,--"֮",
		61295,--"",
	},
	PALADIN = {
		53563,--"}Ř",
		19740,--"ף",
		20217,--"ף",
		--20911,--"ӻ -- passive now?
		1038,--"֮",
		1044,--"֮",
		1022,--"֮",
	},
	WARRIOR = {
		50720,--"o",
		6673,--Yŭ
		469,--֮
	},

	MAGE = {
		130, -- "g"
		1459,--"طx",
		54646,--"ħ",
	},

	WARLOCK = {
		132,--"ɜy[",
		5697,--"ħϢg",
		80398,--ڰD
		20707,--"`ʯͻ",
	},

	DEATHKNIGHT = {
		57330,--"C̖",
	},
}

local CLASS_DEFAULTS = {
	PRIEST = {
		TOPLEFT = { spell = 139, numeric = 1 }, --"֏",
		BOTTOMLEFT = { spell = 33076, other = 1 }, -- "K϶\",
		TOPRIGHT = { spell = 17, other = 1 }, -- "g:",
		BOTTOMRIGHT = { spell = 21562, other = 1, lacks = 1 }, -- "g:g",
	},

	DRUID = {
		TOPLEFT = { spell = 774, numeric = 1 }, --"شg",
		BOTTOMLEFT = { spell = 33763, numeric = 1 }, -- "֮",
		TOPRIGHT = { spell = 48438, numeric = 1 }, -- "ҰȬK",
		BOTTOMRIGHT = { spell = 1126, other = 1, lacks = 1 }, -- "Ұӡӛ",
	},

	SHAMAN = {
		TOPLEFT = { spell = 974 }, --"֮",
		TOPRIGHT = { spell = 61295, numeric = 1 }, -- "",
	},

	PALADIN = {
		TOPLEFT = { spell = 53563, numeric = 1 }, --"}Ř",
		TOPRIGHT = { spell = 20217, other = 1, lacks = 1 }, -- "ף",
		BOTTOMRIGHT = { spell = 19740, other = 1, lacks = 1 }, -- "ף",
	},

	WARRIOR = {
		TOPLEFT = { spell = 469, other = 1 }, --"֮",
		TOPRIGHT = { spell = 6673, other = 1, ignoreMagical = 1 }, --"Yŭ",
		BOTTOMRIGHT = { spell = 50720, other = 1 }, --"o",
	},

	MAGE = {
		TOPLEFT = { spell = 54646, other = 1, ignorePhysical = 1 }, --"ħ",
		BOTTOMRIGHT = { spell = 1459, other = 1, lacks = 1, ignorePhysical = 1 }, --"طx",
	},

	WARLOCK = {
		TOPLEFT = { spell = 80398, other = 1, ignorePhysical = 1 }, --"ڰD",
		TOPRIGHT = { spell = 20707, other = 1 }, --"`ʯͻ",
	},

	DEATHKNIGHT = {
		TOPLEFT = { spell = 57330, other = 1, ignoreMagical = 1 }, --"C̖",
	},
}

local DEFAULTS_INDICATOR = {
	style = 1,
	ignoreOutRanged = 1,
	r = 0, g = 1, b = 0,
	["1"] = { threshold = 50, r = 1, g = 1, b = 0, },
	["2"] = { threshold = 3, r = 1, g = 0, b = 0, },
}

local CLASS = select(2, UnitClass("player"))

function module:GetClassDefaults(class, corner)
	local data = CLASS_DEFAULTS[class]
	data = data and data[corner]
	if data then
		return data.spell, data.numeric, data.other, data.lacks, data.ignorePhysical, data.ignoreMagical
	end
end

local key
for _, key in ipairs(module.INDICATOR_KEYS) do
	local data = {}
	CompactRaid:CloneTable(DEFAULTS_INDICATOR, data)
	module.defaultsDB[key] = data
	local spell, numeric, other, lacks, ignorePhysical, ignoreMagical = module:GetClassDefaults(CLASS, key)
	if spell then
		data.aura = GetSpellInfo(spell)
		data.style = numeric and 2 or 1
		data.selfcast = not other and 1 or nil
		data.showlacks = lacks
		data.ignorePhysical = ignorePhysical
		data.ignoreMagical = ignoreMagical
		data.ignoreVehicle = other or lacks or ignorePhysical or ignoreMagical
	end
end