------------------------------------------------------------
-- SoloFrames.lua
--
-- Abin
-- 2012/1/03
------------------------------------------------------------

local _G = _G
local RegisterStateDriver = RegisterStateDriver
local UnregisterStateDriver = UnregisterStateDriver

local _, addon = ...

local frame = CreateFrame("Frame", "CompactRaidSoloParentFrame", addon:GetMainFrame(), "SecureFrameTemplate")
frame:SetSize(16, 16)
frame:SetPoint("TOPLEFT")
RegisterStateDriver(frame, "visibility", "[group] hide; show")

local playerFrame = addon:CreateUnitFrame(frame:GetName().."Player", frame, "player")
playerFrame:SetPoint("TOPLEFT")

local petFrame = addon:CreateUnitFrame(frame:GetName().."Pet", frame, "pet", "[nopet] hide; [vehicleui] hide; show")
petFrame.affectContainer = 1
petFrame:SetPoint("TOP", playerFrame, "BOTTOM", 0, -1)

function addon:UpdateSoloMode()
	if addon.db.hidesolo then
		UnregisterStateDriver(frame, "visibility")
		frame:Hide()
	else
		RegisterStateDriver(frame, "visibility", "[group] hide; show")
	end
end

function addon:UpdateSoloSpacing()
	petFrame:ClearAllPoints()
	petFrame:SetPoint("TOP", playerFrame, "BOTTOM", 0, -addon.db.spacing)
	addon:UpdateContainerSize()
end

function addon:GetSoloFrameVisibleSize()
	if petFrame:IsVisible() then
		return addon.db.width, addon.db.height * 2 + addon.db.spacing
	else
		return addon.db.width, addon.db.height
	end
end