------------------------------------------------------------
-- General.lua
--
-- Abin
-- 2012/1/14
------------------------------------------------------------

local _, addon = ...
local L = addon.L

local frame = addon:CreateToolbox("CompactRaidToolboxGeneral", 1, 1, 0)
local menu = frame:CreateMenu(140, GENERAL)

local function GroupToolButton_OnClick(self)
	if addon:IsLeader() then
		self.func()
	else
		addon:PrintPermissionError()
	end
end

local function CreateGroupToolButton(text, func)
	local button = menu:AddClickButton(text, "SecureHandlerStateTemplate")
	button.func = func
	button.OnClick = GroupToolButton_OnClick

	RegisterStateDriver(button, "groupstate", "[group] 1; 0")
	button:SetAttribute("_onstate-groupstate", [[
		if newstate == 0 then
			self:Disable()
		else
			self:Enable()
		end
	]])

	if GetNumPartyMembers() == 0 and GetNumRaidMembers() == 0 then
		button:Disable()
	end

	return button

end

CreateGroupToolButton(ROLE_POLL, InitiateRolePoll)
CreateGroupToolButton(READY_CHECK, DoReadyCheck)

local button = menu:AddClickButton(L["lock position"])
function button:OnClick()
	if addon.db.lock then
		addon.db.lock = nil
		self.check:Hide()
	else
		addon.db.lock = 1
		self.check:Show()
	end
	addon.optionPage.lockCheck:SetChecked(addon.db.lock)
end

-- Need to update the checkmark in case user made changes in the option page
button:SetScript("OnShow", function(self)
	if addon.db.lock then
		self.check:Show()
	else
		self.check:Hide()
	end
end)

button = menu:AddClickButton(SETTINGS.."...")
function button:OnClick()
	addon.optionFrame:Toggle()
end

menu:Finish()