------------------------------------------------------------
-- GroupFilters.lua
--
-- Abin
-- 2012/1/14
------------------------------------------------------------

local wipe = wipe
local GetNumRaidMembers = GetNumRaidMembers
local GetRaidRosterInfo = GetRaidRosterInfo

local _, addon = ...
local L = addon.L


local frame = addon:CreateToolbox("CompactRaidToolboxGroupFilter", 1, 1, 1)
RegisterStateDriver(frame, "visibility", "[group:raid] show; hide")

function addon:UpdateToolFrameVisibility()
	if addon.db.classfilter == 1 then
		UnregisterStateDriver(frame, "visibility")
		frame:Hide()
	else
		RegisterStateDriver(frame, "visibility", "[group:raid] show; hide")
	end
end

local menu = frame:CreateMenu(120, RAID)

local function Button_UpdateCheck(self)
	if self.filterGroup:IsShown() then
		self.check:Show()
	else
		self.check:Hide()
	end
end

local i
for i = 1, 8 do
	local button = menu:AddButton(format(GROUP_NUMBER, i), "SecureHandlerClickTemplate", nil, 1)
	button.check:Show()

	local count = button:CreateFontString(nil, "ARTWORK", "GameFontGreenSmall")
	button.count = count
	count:SetPoint("RIGHT", -4, 0)

	local filterGroup = addon:GetRaidGroup(i)
	button.filterGroup = filterGroup
	button:SetFrameRef("filtergroup", filterGroup)
	button.UpdateCheck = Button_UpdateCheck
	button:SetAttribute("_onclick", [[
		local group = self:GetFrameRef("filtergroup")
		if group:IsShown() then
			group:Hide()
		else
			group:Show()
		end
		self:CallMethod("UpdateCheck")
	]])
end

menu:Finish()

local eventFrame = CreateFrame("Frame", nil, menu)

local raidMembers = {}
local function Frame_OnEvent(self)
	wipe(raidMembers)
	local i
	for i = 1, GetNumRaidMembers() do
		local name, _, group = GetRaidRosterInfo(i)
		if name then
			raidMembers[group] = (raidMembers[group] or 0) + 1
		end
	end

	for i = 1, 8 do
		menu.buttons[i].count:SetText(raidMembers[i])
	end
end

eventFrame:SetScript("OnShow", function(self)
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	Frame_OnEvent(self)
end)

eventFrame:SetScript("OnHide", function(self)
	self:UnregisterAllEvents()
end)