------------------------------------------------------------
-- RaidTargets.lua
--
-- Abin
-- 2012/1/14
------------------------------------------------------------

local UnitExists = UnitExists
local GetRaidTargetIndex = GetRaidTargetIndex
local SetRaidTargetIcon = SetRaidTargetIcon
local UnitPopupButtons = UnitPopupButtons

local _, addon = ...
local L = addon.L

local frame = addon:CreateToolbox("CompactRaidToolboxRaidTargets", 0.5, 0.5, 1)
local menu = frame:CreateMenu(132, BINDING_HEADER_RAID_TARGET)

local function Button_OnClick(self)
	if addon:IsLeader(1) then
		SetRaidTargetIcon(UnitExists("target") and "target" or "player", self:GetID())
	else
		addon:PrintPermissionError()
	end
end

local function Button_OnShow(self)
	local unit = UnitExists("target") and "target" or "player"
	local mark = unit and GetRaidTargetIndex(unit)
	if mark == self:GetID() then
		self.check:Show()
	else
		self.check:Hide()
	end
end

local function Button_OnUpdate(self, elapsed)
	self.elapsed = (self.elapsed or 0) + elapsed
	if self.elapsed > 0.2 then
		self.elapsed = 0
		Button_OnShow(self)
	end
end

local i
for i = 1, 8 do
	local data = UnitPopupButtons["RAID_TARGET_"..i]

	local button = menu:AddClickButton(data.text)
	button:SetID(i)
	button.text:SetTextColor(data.color.r, data.color.g, data.color.b)
	button.OnClick = Button_OnClick
	button:SetScript("OnUpdate", Button_OnUpdate)
	button:SetScript("OnShow", Button_OnShow)

	local icon = button:CreateTexture(nil, "ARTWORK")
	icon:SetSize(16, 16)
	icon:SetPoint("RIGHT", -4, 0)
	icon:SetTexture(data.icon)
	icon:SetTexCoord(data.tCoordLeft, data.tCoordRight, data.tCoordTop, data.tCoordBottom)
end

local button = menu:AddClickButton(UnitPopupButtons["RAID_TARGET_NONE"].text)
button.OnClick = Button_OnClick

menu:Finish()