------------------------------------------------------------
-- WorldMarks.lua
--
-- Abin
-- 2012/1/14
------------------------------------------------------------

local _G = _G
local IsRaidMarkerActive = IsRaidMarkerActive

local _, addon = ...
local L = addon.L

local frame = addon:CreateToolbox("CompactRaidToolboxWorldMarks", 0, 1, 0)
RegisterStateDriver(frame, "visibility", "[group] show; hide")

local menu = frame:CreateMenu(132, L["world marks"])

local function Button_OnClick(self)
	local result
	if GetNumRaidMembers() > 0 then
		result = IsRaidLeader() or IsRaidOfficer()
	elseif GetNumPartyMembers() > 0 then
		result = 1
	end

	if not result then
		addon:PrintPermissionError()
	end
end

local function Button_OnUpdate(self, elapsed)
	self.elapsed = (self.elapsed or 0) + elapsed
	if self.elapsed > 0.2 then
		self.elapsed = 0
		if IsRaidMarkerActive(self:GetID()) then
			self.check:Show()
		else
			self.check:Hide()
		end
	end
end

local i
for i = 1, 5 do
	local _, _, text = strfind(_G["WORLD_MARKER"..i], "(.+)|r(.+)")
	local button = menu:AddButton(text.."|r", "SecureActionButtonTemplate")
	button:SetID(i)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetAttribute("type", "macro")
	button:SetAttribute("macrotext1", "/wm "..i)
	button:SetAttribute("macrotext2", "/cwm "..i)
	button:SetScript("OnUpdate", Button_OnUpdate)
	button:HookScript("OnClick", Button_OnClick)
end

local button = menu:AddButton(REMOVE_WORLD_MARKERS, "SecureActionButtonTemplate")
button:SetAttribute("type", "macro")
button:SetAttribute("macrotext", "/cwm "..ALL)
button:HookScript("OnClick", Button_OnClick)

menu:Finish()